require 'table_print'

module PactBroker
  module Client
    class Matrix
      class TextFormatter

        Line = Struct.new(:consumer, :consumer_version, :provider, :provider_version, :success)

        def self.call(matrix)
          data = matrix[:matrix].collect do | line |
            Line.new(
              lookup(line, :consumer, :name),
              lookup(line, :consumer, :version, :number),
              lookup(line, :provider, :name),
              lookup(line, :provider, :version, :number),
              lookup(line, :verificationResult, :success).to_s
            )
          end

          printer = TablePrint::Printer.new(data)
          printer.table_print
        end

        def self.lookup line, *keys
          keys.reduce(line) { | line, key | line[key] }
        rescue NoMethodError
          "???"
        end
      end
    end
  end
end
